=== debian/changelog ===
libzstd (0.8.0-1) unstable; urgency=medium

  [ Kevin Murray ]
  * New upstream version (Closes: #834114)
  
  [ Andreas Tille ]
  * hardening=+bindnow

 -- Kevin Murray <spam@kdmurray.id.au>  Thu, 21 Jul 2016 10:56:02 +1000
