=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Uploaders: Kevin Murray <spam@kdmurray.id.au>,
 Build-Depends:  debhelper (>= 9),
                 d-shlibs,
-Standards-Version: 3.9.7
+Standards-Version: 3.9.8
 Section: libs
 Homepage: https://github.com/Cyan4973/zstd
 Vcs-Git: https://anonscm.debian.org/git/debian-med/libzstd.git
