=== debian/rules ===
--- 
+++ 
@@ -1,5 +1,10 @@
 #!/usr/bin/make -f
 export DH_VERBOSE = 1
+
+export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow
+
+# Upstream's makefiles will respect PREFIX, and this means we avoid a patch
+export PREFIX=/usr
 
 %:
 	dh $@ --parallel
